\section{Available Tools Assessment}\label{sec:toolsassessment}
We started this work to help the OAuth / OpenID developers to create reliable web services by creating an automated tool capable of detecting vulnerabilities. As core technology we decided to use Burp \cite{burp}, a family suite of  web security tools well-known in the world of penetration testing. This choice has been made due to its ability to handle HTTP messages, both for it being capable of displaying and modifying them, giving us the possibility of developing any type of check on the service taken in consideration. More detailed information can be found on section \ref{implementation}.

At the beginning of the project, two main rules were set that had to be followed during the entire process to deliver a better and well thought-out Burp plugin:
\begin{enumerate}
	\item {\textbf{The Plugin must be implementation agnostic:} this directive aims at having a tool capable of working on well-known Oauth / OpenID implemetation, as well as new ones and help every developer to know if his / her work lacks on some security concerns.}
	\item {\textbf{The Plugin must cover for every best current practice:} this two protocols, described in the previous chapters, are standards, which means there are guidelines which \textit{can} be followed.}
\end{enumerate}

We payed attention on the first one during the entire development, making sure every check did not rely on any implementation-dependent information or setting. This was made possible by basing every part of the tool, both its flow and check architecture, on solely parameters required or always available in every implementation of the standard.

The second rule required an extra step before the actual development of the plugin: a search of the already available tools that perform automated checks on OAuth / OpenID web services. This step has been made in order to have an idea on the current situation of the acquirable tools for the public and to define perfectly what had to be implemented or not in the plugin. Specifically to the latter, this information was essential to avoid the implementation of checks already present in the found tools.

To gather the information needed, many platforms / methods have been used, given the fact that many applications / tools were spread on many of them:
\begin{description}
	\item[Web search engines: ]{search engines have been select because some findings were on specific websites hosted to describe the applications developed, or articles written on it.}
	\item[Git public repositories: ]{this platforms allow developers to both interact with each other to improve their work and also release their product in the easiest way possible.}
	\item[Google Scholars]{in this specific version of the well-known search engine, searches about scholarly literature is made more simple and it helped us find articles about tools and their implementations.}
\end{description}

\subsection{Search Results}

The research resulted in many wide variety of tools, both on a architectural and complexity point of view. One key aspect of the problem that we are facing is that OAuth and OpenID can be utilized on web services, may them be a simple website that prefers credentials management to be simple and relies on these two protocols, but also mobile applications installed on miscellaneous devices that can prefer the same approach to the same problem.

As the platforms differ from each other considerably, the implementations of the protocols do too. Two points which can describe easily the contrast  in implementation for given platform are the Client role and the grant type. Usually Clients regarding the mobile platform are called \textbf{native apps} and following RFC 8252\cite{RFC8252oauthfornatapps} terminology it can be described as an application installed by the user to their device which is distinct from a web app that runs in the browser context only. 

Usually, the best and most used grant type is \textit{authorization code type} because it can deliver security and privacy for the user credentials and does not rely on trusting any third-party application, but native apps can be trusted due to their nature. In the recent year we have seen a extensive growth in \textbf{app stores}, centralized digital shops that distribute application directly to the user. Their best feature is that many of them perform checks on the available item that they hand out, ensuring no malicious-code, allowing the use of implicit grant type or Client Credential grant type. Unfortunately sometimes this is not the case, because app stores are not the only mean for obtaining applications as they can be download from different web sites and not be genuine. This issue is the reason why the \textit{authorization code} grant type and the use of external user-agent are still recommended in general.

This brief description can make you understand why every of the developers for automated vulnerabilities testing decided to focus either on web services or mobile applications for their tools and that is why the research gave a clear distinction between them. For example web services tools opted for browsers extension that can directly handle HTTP packets and mobile apps opted for emulators working on smartphones.

Table \ref{table:tools1} and \ref{table:tools2} will describe the findings, splitting the between the targeted role in the checks.
\vspace{2cm}

\input{tooltable.tex}
\newpage